/**
 * DONT USE, Byte level mask generated by vspcplay are not yet usable.
 */
#include <stdio.h>
#include <unistd.h>

static unsigned char g_cfg_filler = 0;
static unsigned char used[0x10000];
static unsigned char packed_mask[8192];

void applyBlockMask(char *filename);

int main(int argc, char **argv)
{
	char mask_file[2048];
	char *spc_file;
	char *t;
	
	if (argc<2) {
		printf("Usage: ./applymask spc_file [filler]\n");
		printf("\n");
		printf("If a .msk file is found in the same directory than the\n"
				".spc file, the mask will be applied on it. If no filler\n"
				"is specified (One byte, usually given in hex), unused\n"
				"areas will be filled with NULs\n");
		return 0;
	}

	spc_file = argv[1];

	strcpy(mask_file, spc_file);

	if (argc>=3) {
		g_cfg_filler = strtol(argv[2], NULL, 0);
	}
	
	t = strrchr(mask_file, '.');
	if (!t) {
		// no extension?
		fprintf(stderr, "Invalid filename\n");
		return 1;
	}

	sprintf(t, ".msk");
	printf("Spc file: %s\n", spc_file);
	printf("Mask file: %s\n", mask_file);

	if (access(spc_file, W_OK)) {
		perror("No write access to spc file");
		return 1;
	}

	if (access(mask_file, R_OK)) {
		perror("No read access from mask file");
		return 1;
	}
	
	if (load_mask(mask_file)==-1) {
		fprintf(stderr, "Mask load error\n");
		return 1;
	}

	printf("Applying pattern $%02X:\n", g_cfg_filler);
	applyBlockMask(spc_file);

	return 0;
}

int load_mask(char *filename)
{
	FILE *fptr;
	int i;

	fptr = fopen(filename, "r");
	fseek(fptr, 32, SEEK_CUR); // skip the 256bytes block mask
	
	if (fread(packed_mask, 8192, 1, fptr)==-1) {
		perror("fread");
		return -1;
	}

	fclose(fptr);

	for (i=0; i<65536; i++) {
		used[i] = packed_mask[i>>3] & (128>>(i%8));
	}

	// HACK: Keep direct pages
	for (i=0; i<512; i++) {
		used[i] = 1;
	}
	
	return 0;
}

void applyBlockMask(char *filename)
{
	FILE *fptr;
	unsigned char nul=g_cfg_filler;
	int i;

	fptr = fopen(filename, "r+");
	if (!fptr) { perror("fopen"); }

	fseek(fptr, 0x100, SEEK_SET);
	printf("[");
	for (i=0; i<65536; i++)
	{
		if (!used[i]) {
			printf(".");
			fwrite(&nul, 1, 1, fptr);
		} else {
			fseek(fptr, 1, SEEK_CUR);
			printf("o");
		}
		fflush(stdout);
	}
	printf("]\n");
	
	fclose(fptr);
}


